<?php
/**
* @version		1.5j
* @copyright		Copyright (C) 2007-2009 Stephen Brandon
* @license		GNU/GPL
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modMetaModHelper
{
	
	function locateGeoIPInclude($use_geoip) {

		// determine which file we are going to import, based on MetaMod parameter
		$geoIPDataFiles = array('','GeoIP.dat','GeoLiteCity.dat','GeoIPCity.dat');

		$geoip_folders = //MetaModParameters::geoIPFolders();
			array(
				"geoip".DS,
				"GeoIP".DS,
				"geoIP".DS,
				"GEOIP".DS,
				"GEO IP".DS,
				'',
				"geo_ip".DS,
				"geo_IP".DS,
				"Geo_IP".DS
				);
		$file = '';
		// find the file in any of the standard locations
		foreach ($geoip_folders as $folder) {
			$target = $geoIPDataFiles[$use_geoip];
			$proposed_file = JPATH_SITE.DS.$folder.DS.$target;
			if (is_file($proposed_file) && is_readable($proposed_file)) {
				$file = $proposed_file;
				break;
			}
		}
		return $file;		
	}
	
	function languages(&$params)
	{
		$debug 			= trim( $params->get( 'debug', '0' ) );
		$opt_option		= trim( $params->get( 'language_option', '0' ) );
		$opt_compare_strict	= trim( $params->get( 'language_compare_strict', '1' ) );
		$opt_preferred		= trim( $params->get( 'language_preferred', '' ) );
		// for $language_preferred, order doesn't matter. MetaMod will just
		// look through the browser's list of languages one at a time, and
		// use the first one that also appears in $language_preferred.

		$language = '';
		$language_code = '';
		$language_region = '';
		$languages = explode(",",array_key_exists('HTTP_ACCEPT_LANGUAGE',$_SERVER) ? $_SERVER['HTTP_ACCEPT_LANGUAGE'] : '');


		if ($opt_option == 0) {
			// main browser lang
			if (count($languages)) {
				$language = strtolower($languages[0]);
			}
		}

		if ($opt_option == 1) { // preferred language from list
			// want to go through each of the languages in the browser string, from the 1st one,
			// and see if any of these are in the list that the admin supplied.
			$preferred_languages = explode(",",$opt_preferred);
			for ($i = 0 ; $i < count($preferred_languages); $i++) {
				$preferred_languages[$i] = trim(strtolower( $preferred_languages[$i] ));
			}

			for ($i = 0 ; $i < count($languages); $i++) {
				// first get rid of ";q=XX" suffixes 
				$l = explode( ";", trim(strtolower( $languages[$i] )));
				$try_this = $l[0];
				preg_match("/([a-z]+)-/",$try_this,$try_this_matches);
				if (
					// strict or not strict, both need this
					in_array($try_this, $preferred_languages)
					||
					// if not strict, try the browser "major" type against "preferred" ones
					( !$opt_compare_strict && count($try_this_matches) > 0 && in_array($try_this_matches[1], $preferred_languages) ) 

				) {
					$language = $try_this;
					break;
				}
			}
		}

		if ($opt_option == 2) {
			// The language of the Joomla front-end
			global $mainframe;
			$language = strtolower($mainframe->getCfg('language'));
		}

		if ($language != '') {
			preg_match("/([a-z]+)(-([a-z]+))?/",$language,$language_matches);
			$language_code = $language_matches[1];
			if (count($language_matches) > 3) $language_region = $language_matches[3];
		}
		if ($debug) {
			echo '<i>$language:</i> '.htmlentities($language).'<br>';
			echo '<i>$language_code:</i> '.htmlentities($language_code).'<br>';
			echo '<i>$language_region:</i> '.htmlentities($language_region).'<br>';
		}
		
		return array($language,$language_code,$language_region);
	}

	function timezone_offset($timestamp,$zone) {
		$old_tz = getenv('TZ');
		putenv("TZ=$zone");
		$offset = date("Z",$timestamp);
		putenv("TZ=$old_tz");
    		return $offset;
	}

	function getUserIP() {
		if ( isset( $_SERVER ) ) {
			if ( isset( $_SERVER["HTTP_X_FORWARDED_FOR"]) ) {
				$ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
				if ( $ip != '' && strtolower($ip) != 'unknown' ) {
					$addresses = explode( ',', $ip);
					return $addresses[ count($addresses) - 1 ];
				}
			}

			if (isset($_SERVER["HTTP_CLIENT_IP"]) && $_SERVER["HTTP_CLIENT_IP"] != '' )
				return $_SERVER["HTTP_CLIENT_IP"];

			return $_SERVER["REMOTE_ADDR"];
		}

		if ( $ip = getenv( 'HTTP_X_FORWARDED_FOR' )) {
			if ( strtolower($ip) != 'unknown' ) {
				$addresses = explode( ',', $ip);
				return $addresses[ count($addresses) - 1 ];
			}
		}

		if ($ip = getenv('HTTP_CLIENT_IP')) {
			return $ip;
		}

		return getenv('REMOTE_ADDR');
	}

	function convertToUtf8(&$geoip) {
		if ($geoip == null) return;
		$attributes = get_object_vars($geoip);
		foreach($attributes as $key => $value) $geoip->$key = utf8_encode($value);
	}
	
	function moduleIds(&$params)
	{
		global $Itemid,$option;
		$id = array_key_exists('id',$_REQUEST) ? $_REQUEST['id'] : '';
		$view = array_key_exists('view',$_REQUEST) ? $_REQUEST['view'] : '';
		
		// Retrieve parameters
		$php 				= trim( $params->get( 'php', '' ) );
		$logged_in_users	= intval( $params->get( 'logged_in_users', '0' ) );
		$start_datetime 	= trim( $params->get( 'start_datetime', '' ) );
		$end_datetime 		= trim( $params->get( 'end_datetime', '' ) );
		$timezone 			= trim( $params->get( 'timezone', 'default' ) );
		$use_geoip 			= intval( $params->get( 'use_geoip', '0' ) );
		$module_ids 		= trim( $params->get( 'module_ids', '0' ) );
		$debug 				= trim( $params->get( 'debug', '0' ) );

		if ($timezone == "default") {
			$config	=& JFactory::getConfig();
			$offset = $config->getValue('config.offset') * 3600;
		} else {
			$offset = modMetaModHelper::timezone_offset(time(),$timezone);
		}

		$now_time		= time() + $offset; // can now be compared directly with getData($start_datetime)		
		// if you were to print this date, it should print in the locale set up in Joomla

		if ($debug) {
			echo '<b>MetaMod debug info:</b><br />';
			echo '<i>$option:</i> '.htmlentities($option).'<br />';
			echo '<i>$view:</i> '.htmlentities($view).'<br />';
			echo '<i>$id:</i> '.htmlentities($id).'<br />';
			echo '<i>$Itemid:</i> '.htmlentities($Itemid).'<br />';
			echo '<i>$timezone:</i> '.htmlentities($timezone).'<br />';
		}
		
		// LANGUAGE HANDLING
		list($language,$language_code,$language_region) = modMetaModHelper::languages($params);

		// START AND END TIMES
		// quit if we're not to start yet

		if ($start_datetime != '') {
			$then = &JFactory::getDate($start_datetime);
		 	if ($then->toUnix() > $now_time) {
				if ($debug) {
					echo 'Start date/time has not been reached.<br />';
				}
				return;
			}
			if ($debug) {
				echo 'Start date/time has been reached.<br />';
			}
		}

		// quit if we are too late to display this item
		if ($end_datetime != '') {
			$then = &JFactory::getDate($end_datetime);
			if ($then->toUnix() <= $now_time) {
				if ($debug) {
					echo 'End date/time has already passed.<br />';
				}
				return;
			}
			if ($debug) {
				echo 'End date/time has not passed.<br />';
			}
		}
		
		// INCLUDE AND EXCLUDE COUNTRIES, & GEOIP FUNCTIONALITY
		$include_countries	= strtoupper(trim( $params->get( 'include_countries', '' ) ));
		$exclude_countries	= strtoupper(trim( $params->get( 'exclude_countries', '' ) ));

		static $geoip = null;

		$fromCountryId = defined('_GEOIP_FROM_COUNTRY_ID') ? _GEOIP_FROM_COUNTRY_ID : '';
		$fromCountryName = defined('_GEOIP_FROM_COUNTRY_NAME') ? _GEOIP_FROM_COUNTRY_NAME : '';

		$ip = modMetaModHelper::getUserIP();

		if ($use_geoip) {
			if ($fromCountryId == '' && $fromCountryName == '' && $geoip == null) {

				// find the location of the geoip data file, depending on which we are to use
				$include_file = modMetaModHelper::locateGeoIPInclude($use_geoip);
				if ($include_file == null) {
					$use_geoip = 0;
					if ($debug) {
						echo "<b>ERROR: cannot locate GeoIP data file in any standard location. Disabing GeoIP.</b><br />";
					}
				} else {
					$geoIPFiles = array('','geoip.inc','geoipcity.inc','geoipcity.inc');
				
					// grab the appropriate code for whichever geoip stuff we have 
					if (!function_exists("geoip_open")) {
						include_once(JPATH_SITE . DS . "modules" . DS . "mod_metamod" . DS . "mod_metamod" . DS . "geoip-php4" . DS . $geoIPFiles[$use_geoip]);
					}
				
					// open the data file
					$gi = geoip_open($include_file,GEOIP_STANDARD);

					if ($use_geoip == 1) { // GeoIP Country (free or commercial)
						$fromCountryId = utf8_encode(geoip_country_code_by_addr($gi, $ip));
						$fromCountryName = utf8_encode(geoip_country_name_by_addr($gi, $ip));
					} else { // GeoCity or GeoLiteCity
						$geoip = geoip_record_by_addr($gi, $ip);
						modMetaModHelper::convertToUtf8($geoip);
						$fromCountryId = $geoip->country_code;
						$fromCountryName = $geoip->country_name;
						if ($geoip == null && $debug) {
							echo "No GeoCity info found for ".htmlentities($ip) . ". Using default country.<br />";
						}
					}
					geoip_close($gi);

					// set some defaults if necessary (probably can't happen)
					if ($fromCountryId == '') $fromCountryId = "GB";
					if ($fromCountryName == '') $fromCountryName = "United Kingdom";
					// save these away for next time
					define ("_GEOIP_FROM_COUNTRY_ID",$fromCountryId);
					define ("_GEOIP_FROM_COUNTRY_NAME",$fromCountryName);
				} // we found the geoip data file
			} // we needed to cache the geoip for the current request
		} // we were told to use a particular variant of GeoIP

		if (($fromCountryId || $fromCountryName) && $debug) {
			echo "<i>Country:</i> " .$fromCountryId . "<br />";
			echo "<i>Country Name:</i> " . $fromCountryName . "<br />";
		}

		if($geoip && $debug)
		{
			echo "<i>Country Code 2:</i> " . $geoip->country_code3 . "<br />";
			echo "<i>Region:</i> " .$geoip->region . "<br />";
			echo "<i>City:</i> " .$geoip->city . "<br />";
			echo "<i>Postal Code:</i> " .$geoip->postal_code . "<br />";
			echo "<i>Latitude:</i> " .$geoip->latitude . "<br />";
			echo "<i>Longitude:</i> " .$geoip->longitude . "<br />";
			echo "<i>DMA Code:</i> " .$geoip->dma_code . "<br />";
			echo "<i>Area Code:</i> " .$geoip->area_code . "<br />";
		}						

		if ($use_geoip) {
			if (strlen($include_countries)) {
				// reject if fromCountryId is not in the list
				if (strpos($include_countries,$fromCountryId) === false) {
					if ($debug) {
						echo 'Rejecting: '.$fromCountryId.' is not in include list<br />';
					}
					return;
				}
				if ($debug) {
					echo 'Accepting: '.$fromCountryId.' is in include list<br />';
				}
			}
			if (strlen($exclude_countries)) {
				// reject if fromCountryId is in the list
				if (! (strpos($exclude_countries,$fromCountryId) === false)) {
					if ($debug) {
						echo 'Rejecting: '.$fromCountryId.' is in exclude list<br />';
					}
					return;
				}
				if ($debug) {
					echo 'Accepting: '.$fromCountryId.' is not in exclude list<br />';
				}
			}
		}

		// for access by eval'ed script
		$db 	=& JFactory::getDBO();
		$user 	=& JFactory::getUser();

		// set some useful for access by eval'ed script
		$user_type = strtolower($user->usertype);
		$user_types = array("Public Frontend", "Registered", "Author",
				"Editor", "Publisher", "Manager", "Administrator", "Super Administrator");
		foreach ($user_types as $u) {
			$constant = "MM_USER_" . strtoupper(str_replace(" ","_",$u));
			$constant_not = "MM_USER_NOT_" . strtoupper(str_replace(" ","_",$u));
			if (!defined($constant))	define($constant, ($user_type == strtolower($u)));
			if (!defined($constant_not))	define($constant_not, ($user_type != strtolower($u)));
		}
		
		if (!defined("MM_NOT_LOGGED_IN"))	define("MM_NOT_LOGGED_IN", ($user->id == 0));
		if (!defined("MM_LOGGED_IN"))		define("MM_LOGGED_IN", ! MM_NOT_LOGGED_IN);
		
		if (!defined("MM_DAY_OF_WEEK"))		define("MM_DAY_OF_WEEK", gmdate("w",$now_time)); // 0=Sunday, 6-Saturday
		if (!defined("MM_DAY_OF_MONTH"))	define("MM_DAY_OF_MONTH", gmdate("j",$now_time)); // 1-31
		if (!defined("MM_MONTH"))		define("MM_MONTH", gmdate("n",$now_time)); // 1-12
		if (!defined("MM_YEAR"))		define("MM_YEAR", gmdate("Y",$now_time));
		if (!defined("MM_HOUR"))		define("MM_HOUR", gmdate("G",$now_time)); // 0-23
		if (!defined("MM_MINUTE"))		define("MM_MINUTE", (int)gmdate("i",$now_time)); // 0-59
		if (!defined("MM_SECOND"))		define("MM_SECOND", (int)gmdate("s",$now_time)); // 0-59
		if (!defined("MM_TIME"))		define("MM_TIME", gmdate("His",$now_time)); // 164523 = 16:45:23 = 4:45:23 PM
		if (!defined("MM_DATE"))		define("MM_DATE", gmdate("Ymd",$now_time)); // 20081225 = 25th Dec 2008

		// now check the logged-in-user status.
		// If MM is set up for "only logged in users", and the user is not logged in, quit immediately.
		if ($logged_in_users == 1 ) {
			if ( MM_NOT_LOGGED_IN ) {
				if ($debug) {
					echo 'Logged-in users only; no logged-in user found.<br />';
				}
				return;
			}
			if ($debug) {
				echo 'Logged-in users only; found logged-in user.<br />';
			}
		}
		// If MM is set up for "only non-logged-in users", and the user is logged in, quit immediately.
		if ($logged_in_users == 2 ) {
			if ( MM_LOGGED_IN ) {
				if ($debug) {
					echo 'Non-logged-in users only; a logged-in user was found.<br />';
				}
				return;
			}
			if ($debug) {
				echo 'Non-logged-in users only; found non-logged-in user.<br />';
			}
		}
		
		// get results from php script
		$mods = strlen($php) ? eval(str_replace("\r<br />","\n",str_replace("\n<br />","\n",$php))) : '';

		
		// convert comma-separated list of module ids (specified statically) to an array of integers
		$static_ids = strlen($module_ids) ? array_map("intval",explode(",",$module_ids)) : array();

		// convert comma-separated list of module ids (returned from PHP code) to an array of integers
		if (!is_array($mods)) {
			if (is_numeric($mods)) $mods = array($mods);
			if (is_string($mods))  $mods = array_map("intval",explode(",",$mods));
			if (!is_array($mods))  $mods = array();
		}

		// combine the 2 sets of numbers
		$mods = array_filter(array_merge($static_ids,$mods)); // remove everything equating to "0" / false
		if ($debug) {
			echo 'Including modules: '.implode(', ',$mods).'<br />';
		}
		return $mods; 
	}
	
	function displayModules(&$all_mod_array, &$params) {

		if (is_array($all_mod_array) && count($all_mod_array)) {

			// Get various things incl. user permissions obj
			global $mainframe, $Itemid;
			global $option;
			$id = array_key_exists('id',$_REQUEST) ? $_REQUEST['id'] : '';
			$view = array_key_exists('view',$_REQUEST) ? $_REQUEST['view'] : '';

			$db 	=& JFactory::getDBO();
			$user 	=& JFactory::getUser();
			$aid	= $user->get('aid', 0);

			$all_mod_numbers = "('".implode("','",array_map("intval", $all_mod_array ))."')";
			$query = "SELECT id, title, module, position, content, showtitle, control, params"
			. "\n FROM #__modules AS m"
			. "\n WHERE m.published = 1"
			. "\n AND m.access <= ". (int)$aid
			. "\n AND m.client_id = ". (int)$mainframe->getClientId()
			. "\n AND m.id in $all_mod_numbers"
			. "\n ORDER BY ordering";

			$db->setQuery($query);
			$modules = array();

			if (!($modules = $db->loadObjectList())) {
				JError::raiseWarning( 'SOME_ERROR_CODE', "Error loading Modules: " . $db->getErrorMsg());
				return false; // FIXME - what to do here? Ignore?
			}

			// do some stuff that is found in libraries/joomla/application/module/helper.php
			$total = count($modules);
			for($i = 0; $i < $total; $i++)
			{
				//determine if this is a custom module
				$file					= $modules[$i]->module;
				$custom 				= substr( $file, 0, 4 ) == 'mod_' ?  0 : 1;
				$modules[$i]->user  	= $custom;
				// CHECK: custom module name is given by the title field, otherwise it's just 'om' ??
				$modules[$i]->name		= $custom ? $modules[$i]->title : substr( $file, 4 );
				$modules[$i]->style		= null;
				$modules[$i]->position	= strtolower($modules[$i]->position);
			}


			$document	= &JFactory::getDocument();
			$renderer	= $document->loadRenderer('module');
			$style 		= trim( $params->get( 'force_style', trim( $params->get( 'style', 'table' ) ) ) );

			$contents = '';
			foreach ($modules as $mod)  {
				$attribs = array();
				$attribs['style'] = $style;
				$contents .= $renderer->render($mod, $attribs);
			}
			return $contents;

		}
	}
}